﻿using System;
using System.Linq;
using Telerik.Web.UI;
using Telerik.Web.UI.Gantt;

public partial class Gantt_XmlProvider : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        RadGantt1.Provider = new XmlGanttProvider(Server.MapPath("Tasks.xml"), true);
    }

    protected void RadGantt1_TaskUpdate(object sender, Telerik.Web.UI.Gantt.TaskEventArgs e)
    {
        RadGantt1.DataBind();

        foreach (Task task in e.Tasks)
        {
            var taskToUpdate = RadGantt1.Tasks.First(t => t.ID.Equals(task.ID));
            var timeDiff = task.End - taskToUpdate.End;

            foreach (Dependency successor in taskToUpdate.Successors)
            {
                var successorTask = RadGantt1.Tasks.First(t => t.ID.Equals(successor.SuccessorID));

                successorTask.Start = successorTask.Start.Add(timeDiff);
                successorTask.End = successorTask.End.Add(timeDiff);

                RadGantt1.Provider.UpdateTask(successorTask);
            }
        }
    }

    protected void Page_PreRender(object sender, EventArgs e)
    {
        RadGantt1.DataBind();
    }
}